const USER_PERMISSIONS = require("../models/user").USER_PERMISSIONS;

function check_permissions(onAuthorized, requiredPermissionLevel, check_equality = false) {
  return function (req, res, next) {
    const requestEmitterPermissionLevel = USER_PERMISSIONS[req.user && req.user.role || "NOBODY"];

    //User doesn't have required permissions to access this route
    if (check_equality && requestEmitterPermissionLevel !== requiredPermissionLevel || !check_equality && requestEmitterPermissionLevel < requiredPermissionLevel) {
      req.flash("info", "Vous n'avez pas les autorisations requises pour accéder à cette ressource");
      res.redirect("/");
    }
    else {
      onAuthorized(req, res, next);
    }
  };
}

module.exports = {
  check_permissions,
}